"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import google.protobuf.struct_pb2
import sys

if sys.version_info >= (3, 8):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing_extensions.final
class X509SVIDRequest(google.protobuf.message.Message):
    """The X509SVIDRequest message conveys parameters for requesting an X.509-SVID.
    There are currently no request parameters.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(
        self,
    ) -> None: ...

global___X509SVIDRequest = X509SVIDRequest

@typing_extensions.final
class X509SVIDResponse(google.protobuf.message.Message):
    """The X509SVIDResponse message carries X.509-SVIDs and related information,
    including a set of global CRLs and a list of bundles the workload may use
    for federating with foreign trust domains.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing_extensions.final
    class FederatedBundlesEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        value: builtins.bytes
        def __init__(
            self,
            *,
            key: builtins.str = ...,
            value: builtins.bytes = ...,
        ) -> None: ...
        def ClearField(
            self,
            field_name: typing_extensions.Literal["key", b"key", "value", b"value"],
        ) -> None: ...

    SVIDS_FIELD_NUMBER: builtins.int
    CRL_FIELD_NUMBER: builtins.int
    FEDERATED_BUNDLES_FIELD_NUMBER: builtins.int
    @property
    def svids(
        self,
    ) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[
        global___X509SVID
    ]:
        """Required. A list of X509SVID messages, each of which includes a single
        X.509-SVID, its private key, and the bundle for the trust domain.
        """

    @property
    def crl(
        self,
    ) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[
        builtins.bytes
    ]:
        """Optional. ASN.1 DER encoded certificate revocation lists."""

    @property
    def federated_bundles(
        self,
    ) -> google.protobuf.internal.containers.ScalarMap[builtins.str, builtins.bytes]:
        """Optional. CA certificate bundles belonging to foreign trust domains that
        the workload should trust, keyed by the SPIFFE ID of the foreign trust
        domain. Bundles are ASN.1 DER encoded.
        """

    def __init__(
        self,
        *,
        svids: collections.abc.Iterable[global___X509SVID] | None = ...,
        crl: collections.abc.Iterable[builtins.bytes] | None = ...,
        federated_bundles: (
            collections.abc.Mapping[builtins.str, builtins.bytes] | None
        ) = ...,
    ) -> None: ...
    def ClearField(
        self,
        field_name: typing_extensions.Literal[
            "crl", b"crl", "federated_bundles", b"federated_bundles", "svids", b"svids"
        ],
    ) -> None: ...

global___X509SVIDResponse = X509SVIDResponse

@typing_extensions.final
class X509SVID(google.protobuf.message.Message):
    """The X509SVID message carries a single SVID and all associated information,
    including the X.509 bundle for the trust domain.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SPIFFE_ID_FIELD_NUMBER: builtins.int
    X509_SVID_FIELD_NUMBER: builtins.int
    X509_SVID_KEY_FIELD_NUMBER: builtins.int
    BUNDLE_FIELD_NUMBER: builtins.int
    spiffe_id: builtins.str
    """Required. The SPIFFE ID of the SVID in this entry"""
    x509_svid: builtins.bytes
    """Required. ASN.1 DER encoded certificate chain. MAY include
    intermediates, the leaf certificate (or SVID itself) MUST come first.
    """
    x509_svid_key: builtins.bytes
    """Required. ASN.1 DER encoded PKCS#8 private key. MUST be unencrypted."""
    bundle: builtins.bytes
    """Required. ASN.1 DER encoded X.509 bundle for the trust domain."""
    def __init__(
        self,
        *,
        spiffe_id: builtins.str = ...,
        x509_svid: builtins.bytes = ...,
        x509_svid_key: builtins.bytes = ...,
        bundle: builtins.bytes = ...,
    ) -> None: ...
    def ClearField(
        self,
        field_name: typing_extensions.Literal[
            "bundle",
            b"bundle",
            "spiffe_id",
            b"spiffe_id",
            "x509_svid",
            b"x509_svid",
            "x509_svid_key",
            b"x509_svid_key",
        ],
    ) -> None: ...

global___X509SVID = X509SVID

@typing_extensions.final
class X509BundlesRequest(google.protobuf.message.Message):
    """The X509BundlesRequest message conveys parameters for requesting X.509
    bundles. There are currently no such parameters.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(
        self,
    ) -> None: ...

global___X509BundlesRequest = X509BundlesRequest

@typing_extensions.final
class X509BundlesResponse(google.protobuf.message.Message):
    """The X509BundlesResponse message carries a set of global CRLs and a map of
    trust bundles the workload should trust.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing_extensions.final
    class BundlesEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        value: builtins.bytes
        def __init__(
            self,
            *,
            key: builtins.str = ...,
            value: builtins.bytes = ...,
        ) -> None: ...
        def ClearField(
            self,
            field_name: typing_extensions.Literal["key", b"key", "value", b"value"],
        ) -> None: ...

    CRL_FIELD_NUMBER: builtins.int
    BUNDLES_FIELD_NUMBER: builtins.int
    @property
    def crl(
        self,
    ) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[
        builtins.bytes
    ]:
        """Optional. ASN.1 DER encoded certificate revocation lists."""

    @property
    def bundles(
        self,
    ) -> google.protobuf.internal.containers.ScalarMap[builtins.str, builtins.bytes]:
        """Required. CA certificate bundles belonging to trust domains that the
        workload should trust, keyed by the SPIFFE ID of the trust domain.
        Bundles are ASN.1 DER encoded.
        """

    def __init__(
        self,
        *,
        crl: collections.abc.Iterable[builtins.bytes] | None = ...,
        bundles: collections.abc.Mapping[builtins.str, builtins.bytes] | None = ...,
    ) -> None: ...
    def ClearField(
        self,
        field_name: typing_extensions.Literal["bundles", b"bundles", "crl", b"crl"],
    ) -> None: ...

global___X509BundlesResponse = X509BundlesResponse

@typing_extensions.final
class JWTSVIDRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    AUDIENCE_FIELD_NUMBER: builtins.int
    SPIFFE_ID_FIELD_NUMBER: builtins.int
    @property
    def audience(
        self,
    ) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """Required. The audience(s) the workload intends to authenticate against."""
    spiffe_id: builtins.str
    """Optional. The requested SPIFFE ID for the JWT-SVID. If unset, all
    JWT-SVIDs to which the workload is entitled are requested.
    """
    def __init__(
        self,
        *,
        audience: collections.abc.Iterable[builtins.str] | None = ...,
        spiffe_id: builtins.str = ...,
    ) -> None: ...
    def ClearField(
        self,
        field_name: typing_extensions.Literal[
            "audience", b"audience", "spiffe_id", b"spiffe_id"
        ],
    ) -> None: ...

global___JWTSVIDRequest = JWTSVIDRequest

@typing_extensions.final
class JWTSVIDResponse(google.protobuf.message.Message):
    """The JWTSVIDResponse message conveys JWT-SVIDs."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SVIDS_FIELD_NUMBER: builtins.int
    @property
    def svids(
        self,
    ) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[
        global___JWTSVID
    ]:
        """Required. The list of returned JWT-SVIDs."""

    def __init__(
        self,
        *,
        svids: collections.abc.Iterable[global___JWTSVID] | None = ...,
    ) -> None: ...
    def ClearField(
        self, field_name: typing_extensions.Literal["svids", b"svids"]
    ) -> None: ...

global___JWTSVIDResponse = JWTSVIDResponse

@typing_extensions.final
class JWTSVID(google.protobuf.message.Message):
    """The JWTSVID message carries the JWT-SVID token and associated metadata."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SPIFFE_ID_FIELD_NUMBER: builtins.int
    SVID_FIELD_NUMBER: builtins.int
    spiffe_id: builtins.str
    """Required. The SPIFFE ID of the JWT-SVID."""
    svid: builtins.str
    """Required. Encoded JWT using JWS Compact Serialization."""
    def __init__(
        self,
        *,
        spiffe_id: builtins.str = ...,
        svid: builtins.str = ...,
    ) -> None: ...
    def ClearField(
        self,
        field_name: typing_extensions.Literal[
            "spiffe_id", b"spiffe_id", "svid", b"svid"
        ],
    ) -> None: ...

global___JWTSVID = JWTSVID

@typing_extensions.final
class JWTBundlesRequest(google.protobuf.message.Message):
    """The JWTBundlesRequest message conveys parameters for requesting JWT bundles.
    There are currently no such parameters.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(
        self,
    ) -> None: ...

global___JWTBundlesRequest = JWTBundlesRequest

@typing_extensions.final
class JWTBundlesResponse(google.protobuf.message.Message):
    """The JWTBundlesReponse conveys JWT bundles."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing_extensions.final
    class BundlesEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        value: builtins.bytes
        def __init__(
            self,
            *,
            key: builtins.str = ...,
            value: builtins.bytes = ...,
        ) -> None: ...
        def ClearField(
            self,
            field_name: typing_extensions.Literal["key", b"key", "value", b"value"],
        ) -> None: ...

    BUNDLES_FIELD_NUMBER: builtins.int
    @property
    def bundles(
        self,
    ) -> google.protobuf.internal.containers.ScalarMap[builtins.str, builtins.bytes]:
        """Required. JWK encoded JWT bundles, keyed by the SPIFFE ID of the trust
        domain.
        """

    def __init__(
        self,
        *,
        bundles: collections.abc.Mapping[builtins.str, builtins.bytes] | None = ...,
    ) -> None: ...
    def ClearField(
        self, field_name: typing_extensions.Literal["bundles", b"bundles"]
    ) -> None: ...

global___JWTBundlesResponse = JWTBundlesResponse

@typing_extensions.final
class ValidateJWTSVIDRequest(google.protobuf.message.Message):
    """The ValidateJWTSVIDRequest message conveys request parameters for
    JWT-SVID validation.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    AUDIENCE_FIELD_NUMBER: builtins.int
    SVID_FIELD_NUMBER: builtins.int
    audience: builtins.str
    """Required. The audience of the validating party. The JWT-SVID must
    contain an audience claim which contains this value in order to
    succesfully validate.
    """
    svid: builtins.str
    """Required. The JWT-SVID to validate, encoded using JWS Compact
    Serialization.
    """
    def __init__(
        self,
        *,
        audience: builtins.str = ...,
        svid: builtins.str = ...,
    ) -> None: ...
    def ClearField(
        self,
        field_name: typing_extensions.Literal["audience", b"audience", "svid", b"svid"],
    ) -> None: ...

global___ValidateJWTSVIDRequest = ValidateJWTSVIDRequest

@typing_extensions.final
class ValidateJWTSVIDResponse(google.protobuf.message.Message):
    """The ValidateJWTSVIDReponse message conveys the JWT-SVID validation results."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SPIFFE_ID_FIELD_NUMBER: builtins.int
    CLAIMS_FIELD_NUMBER: builtins.int
    spiffe_id: builtins.str
    """Required. The SPIFFE ID of the validated JWT-SVID."""
    @property
    def claims(self) -> google.protobuf.struct_pb2.Struct:
        """Optional. Arbitrary claims contained within the payload of the validated
        JWT-SVID.
        """

    def __init__(
        self,
        *,
        spiffe_id: builtins.str = ...,
        claims: google.protobuf.struct_pb2.Struct | None = ...,
    ) -> None: ...
    def HasField(
        self, field_name: typing_extensions.Literal["claims", b"claims"]
    ) -> builtins.bool: ...
    def ClearField(
        self,
        field_name: typing_extensions.Literal[
            "claims", b"claims", "spiffe_id", b"spiffe_id"
        ],
    ) -> None: ...

global___ValidateJWTSVIDResponse = ValidateJWTSVIDResponse
